// Code generated by microgen 0.9.1. DO NOT EDIT.

// It is better for you if you do not change functions names!
// This file will never be overwritten.
package transportgrpc

import (
	service "git.perx.ru/perxis/perxis-go/pkg/clients"
	permission "git.perx.ru/perxis/perxis-go/pkg/permission"
	pb "git.perx.ru/perxis/perxis-go/proto/clients"
	commonpb "git.perx.ru/perxis/perxis-go/proto/common"
)

func ListStringToProto(environments []string) ([]string, error) {
	return environments, nil
}

func ProtoToListString(protoEnvironments []string) ([]string, error) {
	return protoEnvironments, nil
}

func PtrClientToProto(client *service.Client) (*pb.Client, error) {
	if client == nil {
		return nil, nil
	}

	var oauth *pb.Client_OAuth
	var tls *pb.Client_TLS
	var apikey *pb.Client_APIKey

	if client.OAuth != nil {
		oauth = &pb.Client_OAuth{
			ClientId:     client.OAuth.ClientID,
			AuthId:       client.OAuth.AuthID,
			TokenUrl:     client.OAuth.TokenURL,
			ClientSecret: client.OAuth.ClientSecret,
		}
	}
	if client.TLS != nil {
		tls = &pb.Client_TLS{
			Subject: client.TLS.Subject,
		}
	}
	if client.APIKey != nil {
		apikey = &pb.Client_APIKey{
			Key:    client.APIKey.Key,
			Rotate: client.APIKey.Rotate,
		}
	}

	return &pb.Client{
		Id:          client.ID,
		SpaceId:     client.SpaceID,
		Name:        client.Name,
		Description: client.Description,
		Disabled:    client.Disabled,
		RoleId:      client.RoleID,
		//Environments: client.Environments,
		//Rules:        rules,
		Oauth:  oauth,
		Tls:    tls,
		ApiKey: apikey,
	}, nil
}

func ProtoToPtrClient(protoClient *pb.Client) (*service.Client, error) {
	if protoClient == nil {
		return nil, nil
	}

	var oauth *service.OAuth
	var tls *service.TLS
	var apikey *service.APIKey

	if protoClient.Oauth != nil {
		oauth = &service.OAuth{
			ClientID:     protoClient.Oauth.ClientId,
			AuthID:       protoClient.Oauth.AuthId,
			TokenURL:     protoClient.Oauth.TokenUrl,
			ClientSecret: protoClient.Oauth.ClientSecret,
		}
	}
	if protoClient.Tls != nil {
		tls = &service.TLS{
			Subject: protoClient.Tls.Subject,
		}
	}
	if protoClient.ApiKey != nil {
		apikey = &service.APIKey{
			Key:    protoClient.ApiKey.Key,
			Rotate: protoClient.ApiKey.Rotate,
		}
	}

	return &service.Client{
		ID:          protoClient.Id,
		SpaceID:     protoClient.SpaceId,
		Name:        protoClient.Name,
		Description: protoClient.Description,
		Disabled:    protoClient.Disabled,
		RoleID:      protoClient.RoleId,
		OAuth:       oauth,
		TLS:         tls,
		APIKey:      apikey,
	}, nil
}

func ListPtrClientToProto(clients []*service.Client) ([]*pb.Client, error) {
	protoClients := make([]*pb.Client, 0, len(clients))
	for _, c := range clients {
		protoClient, _ := PtrClientToProto(c)
		protoClients = append(protoClients, protoClient)
	}
	return protoClients, nil
}

func ProtoToListPtrClient(protoClients []*pb.Client) ([]*service.Client, error) {
	clients := make([]*service.Client, 0, len(protoClients))
	for _, c := range protoClients {
		client, _ := ProtoToPtrClient(c)
		clients = append(clients, client)
	}
	return clients, nil
}

func PtrPermissionRuleToProto(rule *permission.Rule) (*commonpb.Rule, error) {
	if rule == nil {
		return nil, nil
	}
	actions := make([]commonpb.Action, 0, len(rule.Actions))
	for _, a := range rule.Actions {
		actions = append(actions, commonpb.Action(a))
	}
	return &commonpb.Rule{
		CollectionId:    rule.CollectionID,
		Actions:         actions,
		Access:          commonpb.Access(rule.Access),
		HiddenFields:    rule.HiddenFields,
		ReadonlyFields:  rule.DenyWriteFields,
		WriteonlyFields: rule.DenyReadFields,
		ReadFilter:      rule.ReadFilter,
		WriteFilter:     rule.WriteFilter,
		DenyReadFields:  rule.DenyReadFields,
		DenyWriteFields: rule.DenyWriteFields,
	}, nil
}

func ProtoToPtrPermissionRule(protoRule *commonpb.Rule) (*permission.Rule, error) {
	if protoRule == nil {
		return nil, nil
	}
	actions := make([]permission.Action, 0, len(protoRule.Actions))
	for _, a := range protoRule.Actions {
		actions = append(actions, permission.Action(a))
	}
	r := &permission.Rule{
		CollectionID:    protoRule.CollectionId,
		Actions:         actions,
		Access:          permission.Access(protoRule.Access),
		HiddenFields:    protoRule.HiddenFields,
		DenyReadFields:  protoRule.DenyReadFields,
		DenyWriteFields: protoRule.DenyWriteFields,
		ReadFilter:      protoRule.ReadFilter,
		WriteFilter:     protoRule.WriteFilter,
	}
	if len(r.DenyReadFields) == 0 {
		r.DenyReadFields = protoRule.WriteonlyFields
	}
	if len(r.DenyWriteFields) == 0 {
		r.DenyWriteFields = protoRule.ReadonlyFields
	}
	return r, nil
}
